#include "PCH.h"
#include "gfx.h"

#define extern

extern int g_state = 0;

extern HTEXTURE					g_texBlock = 0;
extern hgeSprite*				g_sprFieldBlock[ 8 ] = {0};
extern float g_fBlockWidth=		64.0f;
extern float g_fBlockHeight=	32.0f;

extern HTEXTURE					g_texEnemies = 0;
extern hgeSprite*				g_sprEnemy[8] = {0};

extern HTEXTURE					g_texPlayer;
extern hgeSprite*				g_sprPlayer[3] = {0};

extern HTEXTURE					g_texCannon;
extern hgeSprite*				g_sprCannon;

extern HTEXTURE					g_texFire;
extern hgeSprite*				g_sprFire;

extern HTEXTURE					g_texCrosshair;
extern hgeSprite*				g_sprCrosshair;

extern HTEXTURE					g_texRock;
extern hgeSprite*				g_sprRock;

extern HTEXTURE					g_texRocket;
extern hgeSprite*				g_sprRocket[3] = {0};

extern HTEXTURE					g_texFlame;
extern hgeSprite*				g_sprFlame[2] = {0};

extern HTEXTURE					g_texBackground;
extern hgeSprite*				g_sprBackground;

extern HTEXTURE					g_texStarEffect;
extern hgeSprite*				g_sprStarEffect;

extern HTEXTURE					g_texFlash;
extern hgeSprite*				g_sprFlash;

extern HTEXTURE					g_texHeartEffect;
extern hgeSprite*				g_sprHeartEffect;
extern HTEXTURE					g_texRockEffect;
extern hgeSprite*				g_sprRockEffect;

extern HTEXTURE					g_texGirls[ 5 ];
extern hgeSprite*				g_sprGirls[ 5 ];

extern hgeFont*					g_fntBig;
extern hgeFont*					g_fntSmall;

extern HTEXTURE					g_texSpeakBubble;
extern hgeSprite*				g_sprSpeakBubble;

extern HTEXTURE					g_texGameOver;
extern hgeSprite*				g_sprGameOver;

extern HTEXTURE					g_texTutorialBg;
extern HTEXTURE					g_texTutorial[3];
extern hgeSprite*				g_sprFullScreen;

extern int g_PlayerShipDepth= 10000;
extern int g_PlayerCannonDepth= 20000;
extern int g_EnemyDepth= 30000;
extern int g_TextDepth = 40000;

extern HGE *g_hge=0;

void loadAllGFX()
{
	g_texBlock= g_hge->Texture_Load("../data/block.png");
	
	for( int i= 0; i < 8; ++i )
	{
		DWORD dwColors[]=
		{
			0xffff0000,
			0xff00ff00,
			0xff0000ff,
			0xffffff00,
			0xff00ffff,
			0xffff00ff,
			0xff808080,
			0xffffffff,
		};

		g_sprFieldBlock[ i ]= new hgeSprite(g_texBlock, i != 7 ? 0 : 112.0f, 0, 96.0f, 96.0f);
		g_sprFieldBlock[ i ]->SetHotSpot(16, 16);
		g_sprFieldBlock[ i ]->SetColor( dwColors[ i ] );
		g_sprFieldBlock[i]->SetBlendMode(BLEND_ALPHABLEND);
	}

	g_texEnemies = g_hge->Texture_Load("../data/enemies.png");
	g_sprEnemy[0] = new hgeSprite(g_texEnemies, 8, 13, 81, 73);
	g_sprEnemy[0]->SetHotSpot(40, 36);
	g_sprEnemy[0]->SetBlendMode(BLEND_ALPHABLEND);
	g_sprEnemy[1] = new hgeSprite(g_texEnemies, 89, 9, 79, 78);
	g_sprEnemy[1]->SetHotSpot(39, 38);
	g_sprEnemy[1]->SetBlendMode(BLEND_ALPHABLEND);
	g_sprEnemy[7] = new hgeSprite(g_texEnemies, 184, 8, 37, 39);
	g_sprEnemy[7]->SetHotSpot(18, 19);
	g_sprEnemy[7]->SetBlendMode(BLEND_ALPHABLEND);

	g_texFire = g_hge->Texture_Load("../data/fire.png");
	g_sprFire = new hgeSprite(g_texFire, 0, 0, 64, 64);
	g_sprFire->SetHotSpot(32, 32);
	g_sprFire->SetBlendMode(BLEND_COLORADD);

	g_texPlayer = g_hge->Texture_Load("../data/player.png");
	for( int i= 0; i < 3; ++i )
	{
		DWORD dwColors[]=
		{
			0xffff8080,
			0xff80ff80,
			0xff8080ff,
		};

		g_sprPlayer[ i ]= new hgeSprite(g_texPlayer, 0, 0, 256, 256);
		g_sprPlayer[ i ]->SetColor( dwColors[ i ] );
		g_sprPlayer[ i ]->SetHotSpot( 96, 85 );
		g_sprPlayer[i]->SetBlendMode(BLEND_ALPHABLEND);
	}

	g_texCannon = g_hge->Texture_Load("../data/cannon.png");
	g_sprCannon = new hgeSprite(g_texCannon, 0, 0, 64, 64);
	g_sprCannon->SetHotSpot(29, 37);
	g_sprCannon->SetBlendMode(BLEND_ALPHABLEND);

	g_texCrosshair = g_hge->Texture_Load("../data/crosshair.png");
	g_sprCrosshair = new hgeSprite(g_texCrosshair, 0, 0, 64, 64);
	g_sprCrosshair->SetHotSpot(32, 32);
	g_sprCrosshair->SetBlendMode(BLEND_ALPHABLEND);

	g_texRock = g_hge->Texture_Load("../data/rock.png");
	g_sprRock = new hgeSprite(g_texRock, 0, 0, 128, 128);
	g_sprRock->SetHotSpot(64, 64);
	g_sprRock->SetBlendMode(BLEND_ALPHABLEND);

	g_texRocket = g_hge->Texture_Load("../data/rocket.png");
	g_sprRocket[0] = new hgeSprite(g_texRocket, 0, 0, 14, 22);
	g_sprRocket[0]->SetHotSpot(6, 11);
	g_sprRocket[1] = new hgeSprite(g_texRocket, 21, 0, 19, 22);
	g_sprRocket[1]->SetHotSpot(9, 11);
	g_sprRocket[2] = new hgeSprite(g_texRocket, 43, 0, 21, 22);
	g_sprRocket[2]->SetHotSpot(11, 11);
	for(int i = 0; i < 3; i++) g_sprRocket[i]->SetBlendMode(BLEND_ALPHABLEND);

	g_texFlame = g_hge->Texture_Load("../data/flame.png");
	g_sprFlame[0] = new hgeSprite(g_texFlame, 12, 12, 26, 62);
	g_sprFlame[0]->SetHotSpot(12, 58);
	g_sprFlame[1] = new hgeSprite(g_texFlame, 60, 12, 26, 62);
	g_sprFlame[1]->SetHotSpot(12, 58);
	for(int i = 0; i < 2; i++) g_sprFlame[i]->SetBlendMode(BLEND_ALPHABLEND);

	g_texBackground = g_hge->Texture_Load("../data/background.png");
	g_sprBackground = new hgeSprite(g_texBackground, 0, 0, 1024, 768);
	g_sprBackground->SetHotSpot(0, 0);

	g_texStarEffect = g_hge->Texture_Load("../data/star.png");
	g_sprStarEffect= new hgeSprite( g_texStarEffect, 0, 0, 96, 96 );
	g_sprStarEffect->SetHotSpot( 47, 47 );
	g_sprStarEffect->SetBlendMode(BLEND_ALPHABLEND);

	g_texHeartEffect = g_hge->Texture_Load("../data/healthheart.png");
	g_sprHeartEffect= new hgeSprite( g_texHeartEffect, 0, 0, 96, 96 );
	g_sprHeartEffect->SetHotSpot( 47, 47 );
	g_sprHeartEffect->SetBlendMode(BLEND_ALPHABLEND);

	g_texRockEffect = g_hge->Texture_Load("../data/rockef.png");
	g_sprRockEffect= new hgeSprite( g_texRockEffect, 0, 0, 64, 64 );
	g_sprRockEffect->SetHotSpot( 32, 32 );
	g_sprRockEffect->SetBlendMode(BLEND_ALPHABLEND);

	g_texFlash = g_hge->Texture_Load("../data/flash.png");
	g_sprFlash = new hgeSprite(g_texFlash, 0, 0, 256, 256);
	g_sprFlash->SetHotSpot(128, 128);
	g_sprFlash->SetBlendMode(BLEND_ALPHABLEND);

	g_texGirls[0] = g_hge->Texture_Load("../data/girl1.png");
	g_texGirls[1] = g_hge->Texture_Load("../data/girl2.png");
	g_texGirls[2] = g_hge->Texture_Load("../data/girl3.png");
	g_texGirls[3] = g_hge->Texture_Load("../data/girl4.png");
	g_texGirls[4] = g_hge->Texture_Load("../data/girl5.png");

	for( int i= 0; i < 5; ++i )
	{
		g_sprGirls[ i ]= new hgeSprite(g_texGirls[i], 192, 206, 272, 320);
		//g_sprPlayer[ i ]->SetColor( dwColors[ i ] );
		g_sprGirls[ i ]->SetHotSpot( 0, 0 );
		g_sprGirls[i]->SetBlendMode(BLEND_ALPHABLEND);
	}

	g_texSpeakBubble = g_hge->Texture_Load("../data/speakbubble.png");
	g_sprSpeakBubble = new hgeSprite(g_texSpeakBubble, 0, 0, 256, 256);

	g_texGameOver = g_hge->Texture_Load("../data/gameover.png");
	g_sprGameOver = new hgeSprite(g_texGameOver, 0, 0, 1024, 1024);
	g_sprGameOver->SetHotSpot(512, 512);

	g_texTutorialBg = g_hge->Texture_Load("../data/tutorialbg.png");
	g_texTutorial[0] = g_hge->Texture_Load("../data/tutorial1.png");
	g_texTutorial[1] = g_hge->Texture_Load("../data/tutorial2.png");
	g_texTutorial[2] = g_hge->Texture_Load("../data/tutorial3.png");
	g_sprFullScreen = new hgeSprite(g_texTutorialBg, 0, 0, 1024, 768);

	g_fntSmall= new hgeFont( "../data/small.fnt" );
	g_fntBig= new hgeFont( "../data/big.fnt" );
}

void unloadAllGFX()
{
	for(int i = 0; i < 8; i++) delete g_sprFieldBlock[i];
	for(int i = 0; i < 8; i++) delete g_sprEnemy[i];
	for(int i = 0; i < 3; i++) delete g_sprPlayer[i];
	delete g_sprCannon;
	delete g_sprFire;
	delete g_sprCrosshair;
	delete g_sprRock;
	for(int i = 0; i < 3; i++) delete g_sprRocket[i];
	for(int i = 0; i < 2; i++) delete g_sprFlame[i];
	delete g_sprBackground;
	delete g_sprFlash;
	for(int i = 0; i < 5; i++) delete g_sprGirls[i];
	delete g_sprSpeakBubble;
	delete g_sprGameOver;
	delete g_sprFullScreen;
	g_hge->Texture_Free(g_texBlock);
	g_hge->Texture_Free(g_texEnemies);
	g_hge->Texture_Free(g_texFire);
	g_hge->Texture_Free(g_texPlayer);
	g_hge->Texture_Free(g_texCannon);
	g_hge->Texture_Free(g_texCrosshair);
	g_hge->Texture_Free(g_texRock);
	g_hge->Texture_Free(g_texRocket);
	g_hge->Texture_Free(g_texFlame);
	g_hge->Texture_Free(g_texBackground);
	g_hge->Texture_Free(g_texFlash);
	for(int i = 0; i < 5; i++) g_hge->Texture_Free(g_texGirls[i]);
	g_hge->Texture_Free(g_texSpeakBubble);
	g_hge->Texture_Free(g_texGameOver);
	g_hge->Texture_Free(g_texTutorialBg);
	for(int i = 0; i < 3; i++) g_hge->Texture_Free(g_texTutorial[i]);
}